#include <windows.h>
#include "resource.h"
int i;
HANDLE hThread;
HWND hMainWnd, BtnWnd[4];
HBITMAP hBufferBMP, hSubBufferBMP;
HBRUSH whiteBrush;
HFONT hFont;
HFONT hMiniFont;
HDC wDC, hBufferDC, hSubBufferDC;
SIZE ScreenSize, SubScreenSize;
RECT ScreenRect, SubScreenRect;
int RefreshASecond = 30;
int FrameSkip = 0;
int MovesPx = 4;
int DotSpeedSet = 1;
int ParabolaSize = 33;
int BlankPx = 100;

struct StageData{
	int Start;
	int Type;
	int Ax;
	int Ay;
	int Bx;
	int By;
	int Cx;
	int Cy;
	int Dx;
	int Dy;
};

struct USERDATA{
	int Level;
	int HS[4];
};

struct LEVELDATA{
	int min;
	int max;
	int goal;
};

COLORREF clrRed, clrBlack;
int bStarted;
int bGameOver;
int DistancePx;
int DisplayPx;
signed int DotSpeed;
signed int DotY;
int KeyPress;
int LoadIndex;
int AllLoaded;
POINT PenPoint[3];
int RefreshedPx[3];
HPEN BoldPen;
int bGameQuit;
int nowLife;
int nowPoint;
int g_Level;
int g_goal;
BOOL bLife;
BOOL bHanten;
BOOL bWaitScreen;
StageData Stage[1024];
USERDATA UserData;
TCHAR ButtonText[4][128];
LEVELDATA LevelData[4];

void SetButtonText();
void LoadUserData();
void LoadDefUserData();
void SaveUserData();
void LoadGameData();
void LoadTop();
void StartGame();
void InitGame();
void QuitGame();
void WaitScreen(int);
void SetSubScreen();
void RefreshBuffer();
void DrawObject();
void RefreshStage();
void DrawBuffer(HDC);
void KeyDown();
void KeyUp();
void TmDrawText();
void CheckScreenColor();

void TmDrawText(HDC hDC , const TCHAR *str , RECT rc , UINT format) {
	DrawText(hDC , str , lstrlen(str) , &rc , format);
}

void GetDirFromFullPath(LPTSTR Dest, LPCTSTR File)
{
	TCHAR* p;
	wcscpy(Dest, File);
	p = wcsrchr(Dest, TEXT('\\'));
	if(p) *p = TEXT('\0');
}

void SetButtonText(){
	int i = 0;
	while(i < (UserData.Level - 1) && i < 4){
		TCHAR strTemp[128];
		//if(i == 3){
		//	swprintf(strTemp, TEXT("%s [5-10px!]"), ButtonText[i]);
		//}else{
			swprintf(strTemp, TEXT("%s [1000!]"), ButtonText[i]);
		//}
		EnableWindow(BtnWnd[i] , TRUE);
		SetWindowText(BtnWnd[i] , strTemp);
		i++;
	}
	if(UserData.Level > 4) return;
	EnableWindow(BtnWnd[i] , TRUE);
	SetWindowText(BtnWnd[i] , ButtonText[i]);
	i++;
	while(i < 4){
		EnableWindow(BtnWnd[i] , FALSE);
		SetWindowText(BtnWnd[i] , ButtonText[i]);
		i++;
	}
}

void LoadUserData(){
	LoadDefUserData();
	TCHAR ModulePath[MAX_PATH];
	TCHAR ModuleDir[MAX_PATH];
	TCHAR UserDataPath[MAX_PATH];
	GetModuleFileName(NULL, ModulePath, MAX_PATH - 1);
	GetDirFromFullPath(ModuleDir, ModulePath);
	swprintf(UserDataPath, TEXT("%s\\savedata.dat"), ModuleDir);
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile(UserDataPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		return;
	}
	ReadFile(hFile, &UserData, sizeof(UserData), &dw, NULL);
	if(dw != sizeof(UserData))
	{
		CloseHandle(hFile);
		MessageBox(hMainWnd, TEXT("USERDATA LOAD ERROR"), TEXT("ERROR"), 0);
		return;
	}
	CloseHandle(hFile);
}

void LoadDefUserData(){
	UserData.Level = 1;
	UserData.HS[0] = 0;
	UserData.HS[1] = 0;
	UserData.HS[2] = 0;
	UserData.HS[3] = 0;
}

void SaveUserData(){
	TCHAR ModulePath[MAX_PATH];
	TCHAR ModuleDir[MAX_PATH];
	TCHAR UserDataPath[MAX_PATH];
	GetModuleFileName(NULL, ModulePath, MAX_PATH - 1);
	GetDirFromFullPath(ModuleDir, ModulePath);
	swprintf(UserDataPath, TEXT("%s\\savedata.dat"), ModuleDir);
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile(UserDataPath, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		MessageBox(hMainWnd, TEXT("USERDATA SAVE ERROR"), TEXT("ERROR"), 0);
		return;
	}
	ReadFile(hFile, &UserData, sizeof(UserData), &dw, NULL);
	WriteFile(hFile, &UserData, sizeof(UserData), &dw, NULL);
	if(dw != sizeof(UserData))
	{
		CloseHandle(hFile);
		MessageBox(hMainWnd, TEXT("USERDATA SAVE ERROR"), TEXT("ERROR"), 0);
		return;
	}
	CloseHandle(hFile);
}

void LoadGameData(int min, int max, int goal){
	g_goal = goal;
	int i = 0;
	for(i = 0; i < goal - 1; i++){
		int sukima;
		Stage[i].Start = 600 + i * 300;
		Stage[i].Type = 0;
		Stage[i].Ax = Stage[i].Start + 10;
		sukima = min + rand() % (max - min);
		Stage[i].Ay = 50 + rand() % (ScreenSize.cy - 100 - sukima);
		Stage[i].By = Stage[i].Ay + sukima;
	}
	Stage[i].Start = 600 + i * 300;
	Stage[i].Type = 15;
	Stage[i].Ax = Stage[i].Start + 10;
}

void LoadTop(){
	RECT Buffer_rc = { 0,0,ScreenSize.cx + BlankPx,ScreenSize.cy};
	FillRect(hBufferDC, &Buffer_rc, whiteBrush);
	SelectObject(hBufferDC, hFont);
	SetTextColor(hBufferDC, RGB(0xFF, 0x80, 0x00));
	RECT Text_rc = {0,0,ScreenSize.cx,75};
	TmDrawText(hBufferDC, TEXT("ParabolaString"), Text_rc, DT_CENTER);
	SelectObject(hBufferDC, hMiniFont);
	SetTextColor(hBufferDC, RGB(0x00, 0x00, 0x80));
	RECT Text_rc2 = {0,ScreenSize.cy - 40,ScreenSize.cx,ScreenSize.cy};
	TmDrawText(hBufferDC, TEXT("(C)2023 TMKSoft - V2.5+"), Text_rc2, DT_CENTER);
	nowPoint = g_goal = nowLife = 0;
	SetSubScreen();
	for(int i = 0; i < 4; i++){
		ShowWindow(BtnWnd[i], SW_SHOW);

		SelectObject(hBufferDC, hMiniFont);
		if(UserData.HS[i] >= (LevelData[i].goal - 1)){
			SetTextColor(hBufferDC, RGB(0xFF, 0x00, 0x00));
		}else{
			SetTextColor(hBufferDC, RGB(0x00, 0x80, 0x00));
		}
		RECT Text_rc3 = {ScreenSize.cx - 60,50 + 45 * i,ScreenSize.cx - 10,90 + 45 *i};
		TCHAR strTemp[8];
		swprintf(strTemp, TEXT("%d"), UserData.HS[i]);
		TmDrawText(hBufferDC, strTemp, Text_rc3, DT_CENTER);
	}
	InvalidateRect(hMainWnd , &ScreenRect , FALSE);
}

void WaitScreen(int Level){
	for(int i = 0; i < 4; i++){
		ShowWindow(BtnWnd[i], SW_HIDE);
	}
	g_Level = Level;
	bWaitScreen = 1;
	RECT Buffer_rc = { 0,0,ScreenSize.cx + BlankPx,ScreenSize.cy};
	FillRect(hBufferDC, &Buffer_rc, whiteBrush);
	SelectObject(hBufferDC, hMiniFont);
	SetTextColor(hBufferDC, RGB(0x00, 0x00, 0x80));
	RECT Text_rc = {0,ScreenSize.cy - 50,ScreenSize.cx,ScreenSize.cy};
	TmDrawText(hBufferDC, TEXT("Press any key to start_"), Text_rc, DT_CENTER);
	InvalidateRect(hMainWnd , &ScreenRect , FALSE);
}

void StartGame(){
	ShowWindow(BtnWnd[4], SW_HIDE);
	if(g_Level >= UserData.Level){
		LoadGameData(LevelData[g_Level - 1].min, LevelData[g_Level - 1].max, LevelData[g_Level - 1].goal);
	}else{
		//if(g_Level == 4){
		//	LoadGameData(5, 10, 11);
		//}else{
			LoadGameData(LevelData[g_Level - 1].min, LevelData[g_Level - 1].max, 1001);
		//}
	}
	bGameOver = 0;
	bStarted = 1;
	InitGame();
	SetTimer(hMainWnd , 1 , RefreshASecond , NULL);
	SetSubScreen();
	SendMessage(hMainWnd, WM_TIMER, 0, 0);
}

void InitGame(){
	RECT Buffer_rc = { 0,0,ScreenSize.cx + BlankPx,ScreenSize.cy};
	FillRect(hBufferDC, &Buffer_rc, whiteBrush);
	DistancePx = 0;
	DisplayPx = 0;
	DotSpeed = 0;
	LoadIndex = 0;
	AllLoaded = 0;
	DotY = 0;
	nowLife = 3;
	nowPoint = 0;
	bLife = 0;
	bHanten = 0;
	PenPoint[1].x = 0;
	PenPoint[1].y = ScreenSize.cy / 2;
	PenPoint[2].x = 0;
	PenPoint[2].y = ScreenSize.cy / 2;
	RefreshedPx[1] = 0;
	RefreshedPx[2] = 0;
}

void QuitGame(){
	KillTimer(hMainWnd, 1);
	bStarted = 0;
	if(UserData.HS[g_Level - 1] < nowPoint){
		UserData.HS[g_Level - 1] = nowPoint;
		SaveUserData();
	}
	if(bGameOver == 1){
		BitBlt(hBufferDC, 0, 0, ScreenSize.cx, ScreenSize.cy, hBufferDC, 0 , 0 , NOTSRCCOPY);
		SelectObject(hBufferDC, hFont);
		SetTextColor(hBufferDC, RGB(0xFF, 0xFF, 0x80));
		RECT Text_rc = {0,0,ScreenSize.cx,75};
		TmDrawText(hBufferDC, TEXT("Game Over"), Text_rc, DT_CENTER);
		SelectObject(hBufferDC, hMiniFont);
		SetTextColor(hBufferDC, RGB(0xFF, 0xFF, 0x00));
		RECT Text_rc2 = {0,ScreenSize.cy - 50,ScreenSize.cx,ScreenSize.cy};
		TmDrawText(hBufferDC, TEXT("Press any key to restart_"), Text_rc2, DT_CENTER);
		ShowWindow(BtnWnd[4], SW_SHOW);
	}else if(bGameOver == 2){
		SelectObject(hBufferDC, hFont);
		SetTextColor(hBufferDC, RGB(0xFF, 0, 0));
		RECT Text_rc = {0,0,ScreenSize.cx,75};
		TmDrawText(hBufferDC, TEXT("CLEAR!!!"), Text_rc, DT_CENTER);
		SelectObject(hBufferDC, hMiniFont);
		SetTextColor(hBufferDC, RGB(0xFF, 0x80, 0x00));
		RECT Text_rc2 = {0,ScreenSize.cy - 50,ScreenSize.cx,ScreenSize.cy};
		TmDrawText(hBufferDC, TEXT("Press any key to show Menu_"), Text_rc2, DT_CENTER);

		if(UserData.Level <= g_Level){
			UserData.Level = g_Level + 1;
			SetButtonText();
			SaveUserData();
		}
	}
	//DrawBuffer(wDC);
}

void SetSubScreen(){
	RECT SubBuffer_rc = { 0,0,SubScreenSize.cx, SubScreenSize.cy};
	FillRect(hSubBufferDC, &SubBuffer_rc, whiteBrush);
	POINT TempPoint[2];
	TempPoint[0].x = 0;
	TempPoint[0].y = 0;
	TempPoint[1].x = 0;
	TempPoint[1].y = SubScreenSize.cy;
	SelectObject(hSubBufferDC , CreatePen(PS_SOLID , 0 , RGB(0, 0, 0)));
	Polyline(hSubBufferDC , TempPoint , 2);
	TCHAR strTemp[8];
	swprintf(strTemp, TEXT("%d\n/%d"), nowPoint, (g_goal - 1) < 0 ? 0 : (g_goal - 1));
	SelectObject(hSubBufferDC, hMiniFont);
	SetTextColor(hSubBufferDC, RGB(0x00, 0x00, 0x00));
	RECT Text_rc = { 0,10,SubScreenSize.cx, 100};
	TmDrawText(hSubBufferDC, strTemp, Text_rc, DT_CENTER);
	swprintf(strTemp, TEXT("%d"), nowLife);
	SelectObject(hSubBufferDC, hMiniFont);
	SetTextColor(hSubBufferDC, nowLife == 1 ? RGB(0xFF, 0x00, 0x00) : RGB(0x00, 0x80, 0x00));
	RECT Text_rc3 = { 0,100,SubScreenSize.cx, 150};
	TmDrawText(hSubBufferDC, strTemp, Text_rc3, DT_CENTER);
	InvalidateRect(hMainWnd , &SubScreenRect , FALSE);
}

void RefreshBuffer(){
	if((DistancePx - RefreshedPx[2]) < MovesPx) return;
	RefreshedPx[0] = RefreshedPx[1];
	RefreshedPx[1] = RefreshedPx[2];
	RefreshedPx[2] = DistancePx;
	if (RefreshedPx[2] > ScreenSize.cx / 2){
		DisplayPx = RefreshedPx[2] - (ScreenSize.cx / 2);
		BitBlt(hBufferDC, 0, 0, ScreenSize.cx + BlankPx - (RefreshedPx[2] - RefreshedPx[1]), ScreenSize.cy, hBufferDC, (RefreshedPx[2] - RefreshedPx[1]) , 0 , SRCCOPY);
	}
	//for(int i = MovesPx; i > 0; i--){
	//	RefreshStage();
	//}
	DrawObject();
	PenPoint[0].y = PenPoint[1].y;
	PenPoint[1].y = PenPoint[2].y;
	PenPoint[2].y = (ScreenSize.cy / 2) - (DotY / ParabolaSize);
	PenPoint[0].x = RefreshedPx[0] - DisplayPx;
	PenPoint[1].x = RefreshedPx[1] - DisplayPx;
	PenPoint[2].x = RefreshedPx[2] - DisplayPx;
	SelectObject(hBufferDC , CreatePen(PS_SOLID , 4 , RGB(0,0,0)));
	Polyline(hBufferDC , PenPoint , 3);
	if(bGameOver){
		QuitGame();
		return;
	}
}

void DrawObject(){
	if(!AllLoaded && (Stage[LoadIndex].Start <= (DisplayPx + ScreenSize.cx))){
		if(Stage[LoadIndex].Type == 0){
			TCHAR strPoint[8];
			swprintf(strPoint, TEXT("%d"), LoadIndex + 1);
			SelectObject(hBufferDC, hMiniFont);
			SetTextColor(hBufferDC, RGB(0x00, 0x00, 0x80));
			RECT Text_rc = {Stage[LoadIndex].Ax - DisplayPx - 60,0,Stage[LoadIndex].Ax - DisplayPx - 10,50};
			TmDrawText(hBufferDC, strPoint, Text_rc, DT_RIGHT);
			POINT TempPoint[2];
			TempPoint[0].x = Stage[LoadIndex].Ax - DisplayPx;
			TempPoint[0].y = 0;
			TempPoint[1].x = Stage[LoadIndex].Ax - DisplayPx;
			TempPoint[1].y = Stage[LoadIndex].Ay;
			SelectObject(hBufferDC , CreatePen(PS_SOLID , 4 , RGB(0,0,0)));
			Polyline(hBufferDC , TempPoint , 2);
			TempPoint[0].x = Stage[LoadIndex].Ax - DisplayPx;
			TempPoint[0].y = Stage[LoadIndex].By;
			TempPoint[1].x = Stage[LoadIndex].Ax - DisplayPx;
			TempPoint[1].y = ScreenSize.cy;
			SelectObject(hBufferDC , CreatePen(PS_SOLID , 4 , RGB(0,0,0)));
			Polyline(hBufferDC , TempPoint , 2);
		}else if(Stage[LoadIndex].Type == 15){
			SelectObject(hBufferDC, hMiniFont);
			SetTextColor(hBufferDC, RGB(0x00, 0x00, 0x80));
			RECT Text_rc = {Stage[LoadIndex].Ax - DisplayPx - 60,0,Stage[LoadIndex].Ax - DisplayPx - 10,50};
			TmDrawText(hBufferDC, TEXT("[G]"), Text_rc, DT_RIGHT);
			POINT TempPoint[2];
			TempPoint[0].x = Stage[LoadIndex].Ax - DisplayPx;
			TempPoint[0].y = 0;
			TempPoint[1].x = Stage[LoadIndex].Ax - DisplayPx;
			TempPoint[1].y = ScreenSize.cy;
			SelectObject(hBufferDC , CreatePen(PS_SOLID , 4 , RGB(0xFF,0,0)));
			Polyline(hBufferDC , TempPoint , 2);
			AllLoaded = 1;
		}
		LoadIndex ++;
	}
}

void RefreshStage(){
	DistancePx ++;
	if(KeyPress){
		DotSpeed += DotSpeedSet;
	}else{
		DotSpeed -= DotSpeedSet;
	}
	DotY += DotSpeed;
	if(Stage[nowPoint].Ax <= DistancePx){
		nowPoint++;
		SetSubScreen();
	}
	if (GetPixel(hBufferDC, DistancePx - DisplayPx, (ScreenSize.cy / 2) - (DotY / ParabolaSize)) == clrBlack) {
		if(!bLife){
			bLife = 1;
			nowLife --;
			SetSubScreen();
			if(!nowLife){
				bGameOver = 1;
			}else{
			bHanten = 4;
			}
		}
	}else{
		bLife = 0;
	}
	if (GetPixel(hBufferDC, DistancePx - DisplayPx, (ScreenSize.cy / 2) - (DotY / ParabolaSize)) == clrRed) {
		bGameOver = 2;
	}
	if ((0 > (ScreenSize.cy / 2) - (DotY / ParabolaSize)) || ((ScreenSize.cy / 2) - (DotY / ParabolaSize) > ScreenSize.cy)) {
		bGameOver = 1;
	}
}

void DrawBuffer(HDC hDC){
	BitBlt(wDC, 0, 0, ScreenSize.cx, ScreenSize.cy, hBufferDC, 0 , 0 , bHanten ? NOTSRCCOPY : SRCCOPY);
	BitBlt(wDC, ScreenSize.cx, 0, SubScreenSize.cx, SubScreenSize.cy, hSubBufferDC, 0 , 0 , SRCCOPY);
}

void KeyDown() {
	if (bWaitScreen) {
		bWaitScreen = 0;
		StartGame();
		KeyPress = 1;
	}else if (bGameOver == 1) {
		StartGame();
		KeyPress = 1;
	}else if (bGameOver == 2) {
		bGameOver = 0;
		LoadTop();
	}else if (!bStarted) {
	//	StartGame();
	//KeyPress = 1;
	}else {
	KeyPress = 1;
	}
}

void CheckScreenColor(){
	HBRUSH redBrush = CreateSolidBrush(RGB(255 , 0 , 0));
	HBRUSH blackBrush = CreateSolidBrush(RGB(0 , 0 , 0));
	RECT Pixel_rc = {0,0,1,1};
	FillRect(hBufferDC, &Pixel_rc, redBrush);
	clrRed = GetPixel(hBufferDC, 0, 0);
	FillRect(hBufferDC, &Pixel_rc, blackBrush);
	clrBlack = GetPixel(hBufferDC, 0, 0);
	DeleteObject(redBrush);
	DeleteObject(blackBrush);
}

void KeyUp() {
	KeyPress = 0;
}

LRESULT CALLBACK WndProc(
	HWND hWnd, 
	UINT msg, 
	WPARAM wParam, 
	LPARAM lParam
){
	PAINTSTRUCT ps;
	switch(msg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case 100:
			WaitScreen(1);
			break;
		case 101:
			WaitScreen(2);
			break;
		case 102:
			WaitScreen(3);
			break;
		case 103:
			WaitScreen(4);
			break;
		case 200:
			ShowWindow(BtnWnd[4], SW_HIDE);
			bGameOver = 0;
			LoadTop();
			break;
		}
	case WM_PAINT:
		DWORD dwID;
		//if(!hThread) hThread = CreateThread(NULL , 0 , ThreadFunc , NULL , 0 , &dwID);
		RefreshBuffer();
		wDC = BeginPaint(hWnd , &ps);
		DrawBuffer(wDC);
		EndPaint(hWnd , &ps);
		break;
	case WM_TIMER:
		if(bHanten) bHanten--;
		//SetWindowPos(hWnd , HWNDTEXTOPMOST , 0, 0 , 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		for(int i = MovesPx; i > 0; i--){
			RefreshStage();
		}
		//DrawBuffer(wDC);
		InvalidateRect(hWnd , &ScreenRect , FALSE);
		break;
	case WM_CREATE:
		RECT rc1;
		RECT rc2;
		GetWindowRect(hWnd, &rc1);
		GetClientRect(hWnd, &rc2);
		SetWindowPos(hWnd, NULL, 0, 0, (rc1.right - rc1.left) - (rc2.right - rc2.left) + 480,
		(rc1.bottom - rc1.top) - (rc2.bottom - rc2.top) + 270, NULL);
		ScreenSize.cx = 400;
		ScreenSize.cy = 270;
		SubScreenSize.cx = 80;
		SubScreenSize.cy = ScreenSize.cy;
		ScreenRect.top = 0;
		ScreenRect.bottom = ScreenSize.cy;
		ScreenRect.left = 0;
		ScreenRect.right = ScreenSize.cx;
		SubScreenRect.top = 0;
		SubScreenRect.bottom = SubScreenSize.cy;
		SubScreenRect.left = ScreenSize.cx;
		SubScreenRect.right = ScreenSize.cx + SubScreenSize.cx;
		wDC = GetDC(hWnd);
		hMainWnd = hWnd;
		whiteBrush = CreateSolidBrush(RGB(255 , 255 , 255));
		BoldPen = CreatePen(PS_SOLID , 4 , RGB(0, 0, 0));
		LOGFONT font;
		font.lfWidth = font.lfEscapement = font.lfOrientation = 0;
		font.lfWeight = FW_LIGHT;
		font.lfItalic = font.lfUnderline = font.lfStrikeOut = FALSE;
		font.lfCharSet = DEFAULT_CHARSET;
		font.lfOutPrecision = OUT_DEFAULT_PRECIS;
		font.lfClipPrecision = CLIP_CHARACTER_PRECIS;
		font.lfQuality = 4;
		font.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
		wcscpy(font.lfFaceName, TEXT("MS Gothic"));
		font.lfHeight = 50;
		hFont = CreateFontIndirect(&font);
		font.lfHeight = 30;
		hMiniFont = CreateFontIndirect(&font);
		hBufferBMP = CreateCompatibleBitmap(wDC, ScreenSize.cx + BlankPx, ScreenSize.cy);
		hBufferDC = CreateCompatibleDC(wDC);
		SelectObject(hBufferDC, hBufferBMP);
		SelectObject(hBufferDC, hFont);
		SetBkMode(hBufferDC, TRANSPARENT);
		hSubBufferBMP = CreateCompatibleBitmap(wDC, SubScreenSize.cx, SubScreenSize.cy);
		hSubBufferDC = CreateCompatibleDC(wDC);
		SelectObject(hSubBufferDC, hSubBufferBMP);
		SelectObject(hSubBufferDC, hFont);
		SetBkMode(hSubBufferDC, TRANSPARENT);
		CheckScreenColor();
		//LoadGameData();
		LoadUserData();
		bStarted = 0;
		bWaitScreen = 0;
		LevelData[0].min = 50;
		LevelData[0].max = 100;
		LevelData[0].goal = 11;
		LevelData[1].min = 30;
		LevelData[1].max = 80;
		LevelData[1].goal = 16;
		LevelData[2].min = 20;
		LevelData[2].max = 50;
		LevelData[2].goal = 21;
		LevelData[3].min = 3;
		LevelData[3].max = 30;
		LevelData[3].goal = 11;
		wcscpy(ButtonText[0], TEXT("PRACTICE"));
		wcscpy(ButtonText[1], TEXT("NORMAL"));
		wcscpy(ButtonText[2], TEXT("HARD"));
		wcscpy(ButtonText[3], TEXT("EXTREME"));
		for(int i = 0; i < 4; i++){
			BtnWnd[i] = CreateWindow(
				TEXT("BUTTON") , TEXT("") ,
				WS_CHILD | BS_PUSHBUTTON ,
				10 , 50 + i * 45 ,  ScreenSize.cx - 70 , 40 ,
				hWnd , (HMENU)(100 + i) , ((LPCREATESTRUCT)lParam)->hInstance , NULL
			);
		}
		BtnWnd[4] = CreateWindow(
			TEXT("BUTTON") , TEXT("Back to Menu") ,
			WS_CHILD | BS_PUSHBUTTON ,
			ScreenSize.cx - 110 , ScreenSize.cy - 100 ,  100 , 50 ,
			hWnd , (HMENU)200 , ((LPCREATESTRUCT)lParam)->hInstance , NULL
		);
		SetButtonText();
		LoadTop();
		//StartGame();
		break;
	case WM_DESTROY:
		DeleteObject(whiteBrush);
		DeleteObject(hSubBufferDC);
		DeleteObject(hSubBufferBMP);
		DeleteObject(hBufferDC);
		DeleteObject(hBufferBMP);
		DeleteObject(BoldPen);
		ReleaseDC(hWnd, wDC);
		PostQuitMessage(0);
		break;
	case WM_LBUTTONDOWN:
			KeyDown();
		break;
	case WM_LBUTTONUP:
		KeyUp();
		break;
	case WM_KEYDOWN:
		if ((lParam & 0x40000000) == 0) {
			KeyDown();
		}
		break;
	case WM_KEYUP:
		KeyUp();
		break;
	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}
int WinMain(
	HINSTANCE hInstance, 
	HINSTANCE hPrevInstance, 
	LPTSTR lpCmdLine, 
	int nCmdShow
){
	if(FindWindow(TEXT("PARASTR"), TEXT("ParabolaString"))) return 0;
	WNDCLASS wc;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = 0;
	wc.hCursor = 0;
	//wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	//wc.hbrBackground = (HBRUSH) CreateSolidBrush(RGB(255 , 0 , 0));
	wc.hbrBackground = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = TEXT("PARASTR");
	if(!RegisterClass(&wc)){
		return 1;
	}
	HWND hWnd = CreateWindowEx(
		WS_EX_TOPMOST | WS_EX_WINDOWEDGE ,
		TEXT("PARASTR"), 
		TEXT("ParabolaString"),
		WS_CAPTION | WS_SYSMENU  ,
		0, 0 ,480 ,300,
		0,
		0,
		hInstance,
		0
	);
	if(!hWnd){
		return 1;
	}
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	MSG msg;
	while(GetMessage(&msg, 0, 0, 0) > 0){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (int)msg.wParam;
}
